// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files)
// DO NOT EDIT

use crate::{ffi, HSTSEnforcer, SessionFeature};
use glib::{prelude::*, translate::*};

glib::wrapper! {
    #[doc(alias = "SoupHSTSEnforcerDB")]
    pub struct HSTSEnforcerDB(Object<ffi::SoupHSTSEnforcerDB, ffi::SoupHSTSEnforcerDBClass>) @extends HSTSEnforcer, @implements SessionFeature;

    match fn {
        type_ => || ffi::soup_hsts_enforcer_db_get_type(),
    }
}

impl HSTSEnforcerDB {
    #[doc(alias = "soup_hsts_enforcer_db_new")]
    pub fn new(filename: &str) -> HSTSEnforcerDB {
        assert_initialized_main_thread!();
        unsafe {
            HSTSEnforcer::from_glib_full(ffi::soup_hsts_enforcer_db_new(filename.to_glib_none().0))
                .unsafe_cast()
        }
    }

    // rustdoc-stripper-ignore-next
    /// Creates a new builder-pattern struct instance to construct [`HSTSEnforcerDB`] objects.
    ///
    /// This method returns an instance of [`HSTSEnforcerDBBuilder`](crate::builders::HSTSEnforcerDBBuilder) which can be used to create [`HSTSEnforcerDB`] objects.
    pub fn builder() -> HSTSEnforcerDBBuilder {
        HSTSEnforcerDBBuilder::new()
    }

    pub fn filename(&self) -> Option<glib::GString> {
        ObjectExt::property(self, "filename")
    }
}

impl Default for HSTSEnforcerDB {
    fn default() -> Self {
        glib::object::Object::new::<Self>()
    }
}

// rustdoc-stripper-ignore-next
/// A [builder-pattern] type to construct [`HSTSEnforcerDB`] objects.
///
/// [builder-pattern]: https://doc.rust-lang.org/1.0.0/style/ownership/builders.html
#[must_use = "The builder must be built to be used"]
pub struct HSTSEnforcerDBBuilder {
    builder: glib::object::ObjectBuilder<'static, HSTSEnforcerDB>,
}

impl HSTSEnforcerDBBuilder {
    fn new() -> Self {
        Self {
            builder: glib::object::Object::builder(),
        }
    }

    pub fn filename(self, filename: impl Into<glib::GString>) -> Self {
        Self {
            builder: self.builder.property("filename", filename.into()),
        }
    }

    // rustdoc-stripper-ignore-next
    /// Build the [`HSTSEnforcerDB`].
    #[must_use = "Building the object from the builder is usually expensive and is not expected to have side effects"]
    pub fn build(self) -> HSTSEnforcerDB {
        self.builder.build()
    }
}
